//
//
//

#ifndef _SC_WAVE_FORMAT_H_
#define _SC_WAVE_FORMAT_H_

#define _CRT_SECURE_NO_DEPRECATE

#include <cstdio>
#include <my_null.h>

class scWaveFormat
{
private:
	char			riff_ary__[ 4 ];	// 'R', 'I', 'F', 'F'
	unsigned long	total_size__;		// t@CTCY - 8
	char			wave_ary__[ 4 ];	// 'W', 'A', 'V', 'E'
	char			fmt_ary__[ 4 ];		// 'f', 'm', 't', ' '
	unsigned long	fmt_size__;			// fmt `NTCY
	unsigned short	format__;			// tH[}bg̎
	unsigned short	channel__;			// `l
	unsigned long	rate__;				// TvO[g
	unsigned long	byte_per_sec__;		// TvO[g * ubN
	unsigned short	block__;			// `l * rbg(8 or 16) / 8
	unsigned short	bit__;				// rbg(8 or 16)
	char			data_ary__[ 4 ];	// 'd', 'a', 't', 'a'
	long			data_size__;		// t@CTCY - 44

	char			*wave_buf__;
	long			wave_sampling_num__;

	//
	void Init__();
	//
	int ReadWaveFileHeader__( std::FILE *arg_fp );
	//
	int ReadWaveFileBody__( std::FILE *arg_fp );
	//
	int ReadWaveFile__( const char *arg_wavefilename );

	//
	int SaveCore__( const char *arg_wavefilename );

	// Ȃo֐
//	scWaveFormat( const scWaveFormat & rhs );					//Rs[RXgN^
//	scWaveFormat & operator = ( const scWaveFormat & rhs );		//Zq
//	scWaveFormat * operator& (){ return this; };				//AhXZq
//	const scWaveFormat * operator& () const{ return this; };	//AhXZq

public:
	// RXgN^
	scWaveFormat();
	// RXgN^
	scWaveFormat( const char *arg_wavefilename );
	// Rs[RXgN^
	scWaveFormat( const scWaveFormat & rhs );
	// fXgN^
	~scWaveFormat();


	// @@@
	// Zq
	scWaveFormat & operator = ( const scWaveFormat & rhs );

	//
	int Channel() const
	{
		return channel__;
	}

	//
	int Alloc( unsigned short arg_channel, unsigned short arg_bit, unsigned long arg_rate, long arg_wave_sampling_num );
	//
	long SamplingNum() const;
	double Length_Sec() const;
	int Volume( double arg_sec, int *arg_vol_right,  int *arg_vol_left ) const;
	int VolumeMinMax( double arg_start_sec, double arg_length_sec, int arg_channel, int *arg_vol_min,  int *arg_vol_max ) const;

	//
	int Save( const char *arg_wavefilename );
	//
	int Load( const char *arg_wavefilename );
	//
	int ToMonaural();
	//
//	scWaveFormat Trim( double srg_start_sec, double srg_length_sec ) const;
	void Trim( double srg_start_sec, double srg_length_sec );
	//
	void Bit08();

	//
//	int Trim( const char *arg_filename, double srg_start_sec, double srg_length_sec );
	//
	int CopyTo( scWaveFormat *arg_input_instance ) const;

};


#endif	// _SC_WAVE_FORMAT_H_



